   S29 = "VoiceON ver 1.1     " ; 20 chars long
   LEGEND S29
   S28 = "talker.ovl"           ; Our overlay file
   S27 = "pc-vco.exc"           ; Our exception file
;
; ----- VoiceON: Scripted interface to VOICE.EXE: Turn VOICE ON
;
;	R.McG; 3/90, Chicago
; ----------------------------------------------------------------
; Usages:
;	  S29 -----> Legend line
;	  S28 -----> Our own overlay file name
;	  S27 -----> Our exception file
;
; -----------------------------------------------------------------------
;	NOTE: This script terminates a previously loaded overlay
; -----------------------------------------------------------------------
;
;	Set-up the overlay (our interface to VOICE.EXE).
;	.. define an end entry pt of '9' at the same time
;
   OVERLAY S28	9			; Load our overlay (end entry pt = 9)
   IF FAILED				; Stop here if can't load overlay
      MESS "!Cannot overlay file: "*S28*"!"
      GOTO Exit
      ENDIF
;
;	Use the overlay to 'open' the driver
;
   SCALL 6,N0				; Entry addr 6 -> open_talk
   IF NOT ZERO N0			; If anything but zero rtnd
      MESS "!Cannot open voice driver!"
      IF NOT ISFILE "voice.exe" MESS "!VOICE.EXE must be on current subdir!"
      OVERLAY CLEAR
      GOTO Exit
      ENDIF
;
;	Load an exception file, if its present
;
   SCALL 12,S27,N0			; Entry addr 12 -> Load exception file
   IF NOT ZERO N0			; If anything but zero rtnd
      MESS "!Exception file load error: "*N0*" using: "*S27*"!"
      ENDIF				; Not fatal error
   MESS "Voice ON!"                     ; Inform
;
;	Ensure VOICE.EXE is unloaded before COM-AND terminates
;
   set exit "VOICEOFF.cmd"              ; Execute before Alt-X
;
;	Return according the manner in which we were called
;
Exit:
   IF FCALLED FRET			; Return if called
   EXIT 				; Else stop script
