/* packetio.h */

#define PACKET_INTERVAL 200 /* packet interval in ms */

#define PACKET_MAX   0x400  /* max. packetsize is 1k */

#define PACKET_IN   0x01
#define PACKET_QOUT 0x02

#if SYS_PROTOS

int PacketFlush(unsigned long ptime);
int PacketSetParams(int size,int bitcode,char *pad);
int PacketInit(void);
void PacketSetId(unsigned char local,unsigned char remote);

void LineWrite(char *buf,int nbytes);
int LineRead(char *buf,int nbytes);
void DataWrite(char *buf,int nbytes,int fmark);
int DataRead(char *buf,int nbytes,int *fmark);

#else

int PacketFlush();
int PacketSetParams();
int PacketInit();
void PacketSetId();

void LineWrite();
int LineRead();
void DataWrite();
int DataRead();

#endif

