/*****************************************************
 * tty.c : Posix tty handling
 *
 * by Jouni Lepp{j{rvi (C) 1992
 *****************************************************/

#include <termios.h>
#include "tty.h"

static struct termios _oldParams;

void TtyStore()
{
  tcgetattr(0,&_oldParams);
}

void TtyRestore()
{
  tcsetattr(0,TCSAFLUSH,&_oldParams); 
}

void TtyRaw()
{
  struct termios params;

  params = _oldParams;

  params.c_cc[VMIN] = 0;
  params.c_cc[VTIME] = 0;
  params.c_iflag = 0;
  params.c_oflag = 0;
  params.c_lflag = 0;
  params.c_line  = 0;
  tcsetattr(0,TCSAFLUSH,&params);
}

void TtySane()
{
#ifdef TIOCSWINSZ
  struct winsize ws;
#endif 

  TtyRestore();

#ifdef TIOCSWINSZ
  ws.ws_row = 24;
  ws.ws_col = 80;
  ioctl(0,TIOCSWINSZ,&ws);
#endif
}
