@echo off
cls

echo ---------------------------------------------------------
echo   FrontDoor Terminal Protocol Batch v2.1 - (C) UGR 1993
echo ---------------------------------------------------------

rem --------------------------------------------------------------------------
rem   Einbindung des FrontDoor/Terminal-Batches unter :     
rem   -------------------------------------------------
rem   fdsetup/Terminal/Miscellaneous/Editor als FDT_PROT.BAT
rem --------------------------------------------------------------------------

rem --------------------------------------------------------------------------
rem   Globale Settings :
rem   ------------------
rem   COMPORT = Verwendeter serieller Port
rem   PROTDIR = Verzeichnis zu den Protokollen (mit Backslash!)
rem   DOWNDIR = Verzeichnis fuer Downloads (mit Backslash!)
rem   UPLODIR = Verzeichnis fuer Uploads (mit Backslash!)
rem   DSZVERS = DSZ/GSZ registriert/unregistriert REG/UNREG
rem   WAITVAL = Wartezeit falls ein Fehler auftrat
rem   ESTBAUD = Die Geschwindigkeit des Modems - dies laesst sich leider
rem             nicht aus FD entnehmen, daher einen Standard-Wert einstellen.
rem             Da ja eh ein Fossil-Treiber aktiv ist spielt der Wert nur fr
rem             die Zeitberechnung eine Rolle.
rem   LOKBAUD = Geschwindigkeit der geLOCKten Schnittstelle. Falls nicht
rem             vorhanden gleich ESTBAUD setzen.
rem --------------------------------------------------------------------------

set COMPORT=3
set PROTDIR=c:\superbbs\pro\
set DOWNDIR=c:\front\down\
set UPLODIR=c:\front\up\
set DSZVERS=REG
set WAITVAL=5
set ESTBAUD=2400
set LOKBAUD=2400

rem ---------------------------------------------
rem   War genug Environment-Speicher vorhanden ?
rem ---------------------------------------------

if "%COMPORT%"=="" goto ENV_ERR
if "%PROTDIR%"=="" goto ENV_ERR
if "%DOWNDIR%"=="" goto ENV_ERR
if "%UPLODIR%"=="" goto ENV_ERR
if "%DSZVERS%"=="" goto ENV_ERR
if "%WAITVAL%"=="" goto ENV_ERR
if "%ESTBAUD%"=="" goto ENV_ERR
if "%LOKBAUD%"=="" goto ENV_ERR

rem --------------------------------------------------------------------------
rem   Parameter die beim Aufruf zu uebergeben sind :
rem   ----------------------------------------------
rem   Die uebergebenen Parameter waehlen das Protokoll aus und veranlassen
rem   (falls vorhanden) den Upload mit dem/den angebenen Filenamen.
rem
rem   1. Parameter (Protokoll-Auswahl)
rem
rem   DSZ oder dsz   = DSZ                
rem   MPT oder mpt   = MPT/Puma
rem   JMD oder jmd   = JModem Download
rem   JMU oder jmu   = JModem Upload
rem   BIM oder bim   = BiModem
rem   BIP oder bip   = BiModem Pro (Pampa)
rem   HSL oder hsl   = HS/Link
rem   SZM oder szm   = SZModem
rem
rem   2. Parameter und Folgende (optional) - Filename(n) fuer den Upload
rem      Der Pfad zu den Uploads wird angefuegt, es sind nur die Dateinamen
rem      zu bergeben.
rem 
rem   Z.B. :  1.txt 2.txt 3.txt
rem           filename.ext
rem           usw.
rem --------------------------------------------------------------------------

rem --------------------------------------------------------------------------
rem   Sprungmarken :
rem   --------------
rem   DSZ_DL             DSZ/GSZ Download
rem   DSZ_UL             DSZ/GSZ Upload
rem   MPT_DL             MPT/Puma Download
rem   MPT_UL             MPT/Puma Upload
rem   JMOD_DL            JModem Download
rem   JMOD_UL            JModem Upload
rem   BI_DL              BiModem Download
rem   BI_UL              BiModem (zustzlich) Upload
rem   BIP_DL             BiModem Pro Download
rem   BIP_UL             NiModem Pro (zustzlich) Upload
rem   HSL_DLUL           HS/Link Up- und Download
rem   SZM_DL             SZModem Download
rem   SZM_UL             SZModem Upload
rem -------------------------------------------------------------------------- 
     
rem --------------------------
rem   'Parsing' der Parameter
rem --------------------------

del %PROTDIR%files.lst >NUL
if not "%2"=="" goto PAR_UL                             rem Uploads ?
goto 1_CH_1

:PAR_UL                                                 rem Files nach Liste
echo %UPLODIR%%2>>%PROTDIR%files.lst
if not "%3"=="" echo %UPLODIR%%3>>%PROTDIR%files.lst
if not "%4"=="" echo %UPLODIR%%4>>%PROTDIR%files.lst
if not "%5"=="" echo %UPLODIR%%5>>%PROTDIR%files.lst
if not "%6"=="" echo %UPLODIR%%6>>%PROTDIR%files.lst
if not "%7"=="" echo %UPLODIR%%7>>%PROTDIR%files.lst
if not "%8"=="" echo %UPLODIR%%8>>%PROTDIR%files.lst
if not "%9"=="" echo %UPLODIR%%9>>%PROTDIR%files.lst
goto 1_CH_1
     
:1_CH_1                                                 rem  Abfrage 1/1
if "%1"=="dsz" goto 1_CH_2                              rem  DSZ ?
if "%1"=="DSZ" goto 1_CH_2                              rem  DSZ ?
goto 2_CH_1                                             rem  false

:1_CH_2                                                 rem  Abfrage 1/2
if not exist %PROTDIR%files.lst goto DSZ_DL             rem  Nur Download ?
goto DSZ_UL                                             rem  Upload

:2_CH_1                                                 rem  Abfrage 2/1
if "%1"=="mpt" goto 2_CH_2                              rem  MPT ?
if "%1"=="MPT" goto 2_CH_2                              rem  MPT ?
goto 3_CH_1                                             rem  false

:2_CH_2                                                 rem  Abfrage 2/2
if not exist %PROTDIR%files.lst goto MPT_DL             rem  Nur Download ?
goto MPT_UL                                             rem  Upload

:3_CH_1                                                 rem  Abfrage 3/1
if "%1"=="jmd" goto JMOD_DL                             rem  JModem Download ?
if "%1"=="JMD" goto JMOD_DL                             rem  JModem Download ?
goto 4_CH_1                                             rem  false

:4_CH_1                                                 rem  Abfrage 4/1
if "%1"=="jmu" goto JMOD_UL                             rem  JModem Upload ?
if "%1"=="JMU" goto JMOD_UL                             rem  JModem Upload ?
goto 5_CH_1                                             rem  false

:5_CH_1                                                 rem  Abfrage 5/1
if "%1"=="bim" goto 5_CH_2                              rem  BiModem ?
if "%1"=="BIM" goto 5_CH_2                              rem  BiModem ?
goto 6_CH_1                                             rem  false

:5_CH_2                                                 rem  Abfrage 5/2
if not exist %PROTDIR%files.lst goto BI_DL              rem  Nur Download ?
goto BI_UL                                              rem  Upload

:6_CH_1                                                 rem  Abfrage 6/1
if "%1"=="hsl" goto HSL_DLUL                            rem  HS/Link ?
if "%1"=="HSL" goto HSL_DLUL                            rem  HS/Link ?
goto 7_CH_1                                             rem  false

:7_CH_1                                                 rem  Abfrage 7/1
if "%1"=="szm" goto 7_CH_2                              rem  SZModem ?
if "%1"=="SZM" goto 7_CH_2                              rem  SZModem ?
goto 8_CH_1                                             rem  false

:7_CH_2                                                 rem  Abfrage 7/2
if not exist %PROTDIR%files.lst goto SZM_DL             rem  Download ?
goto SZM_UL                                             rem  Upload

:8_CH_1                                                 rem  Abfrage 8/1
if "%1"=="bip" goto 8_CH_2                              rem  BiModem Pro ?
if "%1"=="BIP" goto 8_CH_2                              rem  BiModem Pro ?
goto ENDE_F                                             rem  false

:8_CH_2
if not exist %PROTDIR%files.lst goto BIP_DL             rem  Download ?
goto BIP_UL                                             rem  Upload


:DSZ_DL  
if "%DSZVERS%"=="REG" goto DSZ_DLR
echo -------------------------------------------------------------------
echo DSZ ist unregistriert - Dateien werden im aktuellen Pfad empfangen!
echo -------------------------------------------------------------------
%PROTDIR%dsz.com pG0 port %COMPORT% rz
goto END_BAT
:DSZ_DLR
%PROTDIR%dsz.com pG0 port %COMPORT% rz -Z -m %DOWNDIR%
goto END_BAT

:DSZ_UL  
%PROTDIR%dsz.com pG0 port %COMPORT% sz @%PROTDIR%files.lst
goto END_BAT

:MPT_DL  
%PROTDIR%mpt.exe P%COMPORT% E%ESTBAUD% R %DOWNDIR%
goto END_BAT

:MPT_UL  
%PROTDIR%mpt.exe P%COMPORT% E%ESTBAUD% S @%PROTDIR%files.lst
goto END_BAT

:JMOD_DL 
if "%2"=="" goto JMOD_F
%PROTDIR%jmodem.exe R%COMPORT% %DOWNDIR%%2
goto END_BAT

:JMOD_UL 
if "%2"=="" goto JMOD_F
%PROTDIR%jmodem.exe S%COMPORT% %UPLODIR%%2
goto END_BAT

:BI_DL   
%PROTDIR%bimodem.com /C %PROTDIR%bimodem.cfg /B %LOKBAUD% /L %COMPORT% /R %DOWNDIR%
goto END_BAT

:BI_UL   
%PROTDIR%bimodem.com /C %PROTDIR%bimodem.cfg /B %LOKBAUD% /L %COMPORT% /R %DOWNDIR% /U @%PROTDIR%files.lst
goto END_BAT

:HSL_DLUL
%PROTDIR%hslink.exe -! -K -HS -I2 -R -S4096 -E%ESTBAUD% -P%COMPORT% -U%DOWNDIR% @%PROTDIR%files.lst
goto END_BAT

:SZM_DL  
%PROTDIR%szmodem.exe port %COMPORT% speed %ESTBAUD% rz %DOWNDIR%
goto END_BAT

:SZM_UL  
%PROTDIR%szmodem.exe port %COMPORT% speed %ESTBAUD% sz @%PROTDIR%files.lst
goto END_BAT

:BIP_DL   
%PROTDIR%bimodem.com /B %LOKBAUD% /L %COMPORT% /R %DOWNDIR%
goto END_BAT

:BIP_UL   
%PROTDIR%bimodem.com /B %LOKBAUD% /L %COMPORT% /R %DOWNDIR% /U @%PROTDIR%files.lst
goto END_BAT

:ENV_ERR
cls
echo --------------------------------------------------------
echo Fehler: nicht gengend Environt-Speicher vorhanden!
echo         Erhhe /E:xxxx beim Shell-Aufruf von COMMAND.COM
echo --------------------------------------------------------
wait 5
goto END_BAT

:JMOD_F
cls
echo ---------------------------------------------------
echo Fehler: kein Filename fr JModem-Betrieb angegeben!
echo ---------------------------------------------------
wait %WAITVAL%
goto END_BAT

:ENDE_F
cls
echo ---------------------------------------------------------------
echo Fehler: kein gltiger Parameter zur Protokollauswahl angegeben!
echo ---------------------------------------------------------------
wait %WAITVAL%
goto END_BAT

:END_BAT
set COMPORT=
set PROTDIR=
set DOWNDIR=
set DSZVERS=
set WAITVAL=
set ESTBAUD=
set LOKBAUD=
cls
echo ------------------------------------------------
echo FrontDoor Terminal Protocol Batch v2.0 - beendet
echo ------------------------------------------------
exit
